Index: content/src/main/resources/content/fr/jobfacet.xml
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- content/src/main/resources/content/fr/jobfacet.xml	(revision 36673)
+++ content/src/main/resources/content/fr/jobfacet.xml	(revision )
@@ -34,7 +34,7 @@
     <sv:value>Employeur</sv:value>
   </sv:property>
   <sv:property sv:name="hippofacnav:limit" sv:type="Long">
-    <sv:value>1000</sv:value>
+    <sv:value>200</sv:value>
   </sv:property>
   <sv:property sv:name="hippofacnav:facets" sv:type="String">
     <sv:value>hippogogreen:closingdate$[{name:'Aujourd\'hui', resolution:'day', begin:0, end:0},{name:'Hier', resolution:'day', begin:-1, end:0},{name:'7 derniers jours', resolution:'day', begin:-7, end:1},{name:'15 derniers jours', resolution:'day', begin:-14, end:0}]</sv:value>
\ No newline at end of file
Index: content/src/main/resources/content/es/searchfacets.xml
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- content/src/main/resources/content/es/searchfacets.xml	(revision 36673)
+++ content/src/main/resources/content/es/searchfacets.xml	(revision )
@@ -34,6 +34,6 @@
     <sv:value>not(jcr:primaryType=tcmp:tagcloud)</sv:value>
   </sv:property>
   <sv:property sv:name="hippofacnav:limit" sv:type="Long">
-    <sv:value>1000</sv:value>
+    <sv:value>200</sv:value>
   </sv:property>
 </sv:node>
Index: content/src/main/resources/content/zh/products.xml
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- content/src/main/resources/content/zh/products.xml	(revision 36673)
+++ content/src/main/resources/content/zh/products.xml	(revision )
@@ -783,27 +783,27 @@
     </sv:node>
   </sv:node>
   <sv:node sv:name="facetedproducts">
-  <sv:property sv:name="jcr:primaryType" sv:type="Name">
-    <sv:value>hippofacnav:facetnavigation</sv:value>
-  </sv:property>
-  <sv:property sv:name="hippo:docbase" sv:type="String">
-    <sv:value>84d6e439-6a58-4887-9d7e-707814a2c659</sv:value>
-  </sv:property>
-  <sv:property sv:name="hippofacnav:skipresultsetfacetsavailable" sv:type="Boolean">
-    <sv:value>true</sv:value>
-  </sv:property>
-  <sv:property sv:multiple="true" sv:name="hippofacnav:facetnodenames" sv:type="String">
-    <sv:value>价格</sv:value>
-    <sv:value>查看产品</sv:value>
-    <sv:value>评价</sv:value>
-  </sv:property>
-  <sv:property sv:multiple="true" sv:name="hippofacnav:facets" sv:type="String">
-    <sv:value>hippogogreen:price$[{name:'¥ 0 - ¥ 25', resolution:'double', end:25}, {name:'¥ 25 - ¥ 50', resolution:'double', begin:25, end:50}, {name:'¥ 50 - ¥ 100', resolution:'double', begin:50, end:100}, {name:'¥ 100 - ¥ 250', resolution:'double', begin:100, end:250}, {name:'¥ 250 - ¥ 500', resolution:'double', begin:250, end:500}, {name:'¥ 500 en meer', resolution:'double', begin:500}]</sv:value>
-    <sv:value>hippogogreen:categories</sv:value>
-    <sv:value>hippogogreen:rating$[{name:'1星级或以上', resolution:'double', begin:1}, {name:'2星或以上', resolution:'double', begin:2}, {name:'3星级或以上', resolution:'double', begin:3}, {name:'4星级或以上', resolution:'double', begin:4}, {name:'5星或以上', resolution:'double', begin:5, end:6}]</sv:value>
-  </sv:property>
-  <sv:property sv:name="hippofacnav:limit" sv:type="Long">
+    <sv:property sv:name="jcr:primaryType" sv:type="Name">
+      <sv:value>hippofacnav:facetnavigation</sv:value>
+    </sv:property>
+    <sv:property sv:name="hippo:docbase" sv:type="String">
+      <sv:value>84d6e439-6a58-4887-9d7e-707814a2c659</sv:value>
+    </sv:property>
+    <sv:property sv:name="hippofacnav:skipresultsetfacetsavailable" sv:type="Boolean">
+      <sv:value>true</sv:value>
+    </sv:property>
+    <sv:property sv:multiple="true" sv:name="hippofacnav:facetnodenames" sv:type="String">
+      <sv:value>价格</sv:value>
+      <sv:value>查看产品</sv:value>
+      <sv:value>评价</sv:value>
+    </sv:property>
+    <sv:property sv:multiple="true" sv:name="hippofacnav:facets" sv:type="String">
+      <sv:value>hippogogreen:price$[{name:'¥ 0 - ¥ 25', resolution:'double', end:25}, {name:'¥ 25 - ¥ 50', resolution:'double', begin:25, end:50}, {name:'¥ 50 - ¥ 100', resolution:'double', begin:50, end:100}, {name:'¥ 100 - ¥ 250', resolution:'double', begin:100, end:250}, {name:'¥ 250 - ¥ 500', resolution:'double', begin:250, end:500}, {name:'¥ 500 en meer', resolution:'double', begin:500}]</sv:value>
+      <sv:value>hippogogreen:categories</sv:value>
+      <sv:value>hippogogreen:rating$[{name:'1星级或以上', resolution:'double', begin:1}, {name:'2星或以上', resolution:'double', begin:2}, {name:'3星级或以上', resolution:'double', begin:3}, {name:'4星级或以上', resolution:'double', begin:4}, {name:'5星或以上', resolution:'double', begin:5, end:6}]</sv:value>
+    </sv:property>
+    <sv:property sv:name="hippofacnav:limit" sv:type="Long">
-    <sv:value>1000</sv:value>
+      <sv:value>200</sv:value>
-  </sv:property>
-</sv:node>
+    </sv:property>
+  </sv:node>
 </sv:node>
Index: content/src/main/resources/content/nl/jobfacet.xml
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- content/src/main/resources/content/nl/jobfacet.xml	(revision 36673)
+++ content/src/main/resources/content/nl/jobfacet.xml	(revision )
@@ -37,7 +37,7 @@
     <sv:value>werkgever</sv:value>
   </sv:property>
   <sv:property sv:name="hippofacnav:limit" sv:type="Long">
-    <sv:value>1000</sv:value>
+    <sv:value>200</sv:value>
   </sv:property>
   <sv:property sv:name="hippofacnav:facets" sv:type="String">
     <sv:value>hippogogreen:closingdate$[{name:'Today', resolution:'day', begin:0, end:0}, {name:'Yesterday', resolution:'day', begin:-1, end:0}, {name:'Last 7 days', resolution:'day', begin:-7, end:1}, {name:'Last 14 days', resolution:'day', begin:-14, end:0}]</sv:value>
Index: content/src/main/resources/content/zh/jobfacet.xml
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- content/src/main/resources/content/zh/jobfacet.xml	(revision 36673)
+++ content/src/main/resources/content/zh/jobfacet.xml	(revision )
@@ -50,6 +50,6 @@
     <sv:value>jcr:primaryType=hippogogreen:job</sv:value>
   </sv:property>
   <sv:property sv:name="hippofacnav:limit" sv:type="Long">
-    <sv:value>1000</sv:value>
+    <sv:value>200</sv:value>
   </sv:property>
 </sv:node>
Index: content/src/main/resources/content/ru/jobfacet.xml
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- content/src/main/resources/content/ru/jobfacet.xml	(revision 36673)
+++ content/src/main/resources/content/ru/jobfacet.xml	(revision )
@@ -33,6 +33,6 @@
     <sv:value>jcr:primaryType=hippogogreen:job</sv:value>
   </sv:property>
   <sv:property sv:name="hippofacnav:limit" sv:type="Long">
-    <sv:value>1000</sv:value>
+    <sv:value>200</sv:value>
   </sv:property>
 </sv:node>
Index: content/src/main/resources/content/de/jobfacet.xml
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- content/src/main/resources/content/de/jobfacet.xml	(revision 36673)
+++ content/src/main/resources/content/de/jobfacet.xml	(revision )
@@ -38,7 +38,7 @@
     <sv:value>Arbeitgeber</sv:value>
   </sv:property>
   <sv:property sv:name="hippofacnav:limit" sv:type="Long">
-    <sv:value>1000</sv:value>
+    <sv:value>200</sv:value>
   </sv:property>
   <sv:property sv:name="hippofacnav:facets" sv:type="String">
     <sv:value>hippogogreen:closingdate$[{name:'Heute', resolution:'day', begin:0, end:0}, {name:'Gestern', resolution:'day', begin:-1, end:0}, {name:'Vergangene 7 Tage', resolution:'day', begin:-7, end:1}, {name:'Vergangene 14 Tage', resolution:'day', begin:-14, end:0}]</sv:value>
Index: content/src/main/resources/content/en/jobfacet.xml
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- content/src/main/resources/content/en/jobfacet.xml	(revision 36673)
+++ content/src/main/resources/content/en/jobfacet.xml	(revision )
@@ -38,7 +38,7 @@
     <sv:value>employer</sv:value>
   </sv:property>
   <sv:property sv:name="hippofacnav:limit" sv:type="Long">
-    <sv:value>1000</sv:value>
+    <sv:value>200</sv:value>
   </sv:property>
   <sv:property sv:name="hippofacnav:facets" sv:type="String">
     <sv:value>hippogogreen:closingdate$[{name:'Today', resolution:'day', begin:0, end:0}, {name:'Yesterday', resolution:'day', begin:-1, end:0}, {name:'Last 7 days', resolution:'day', begin:-7, end:1}, {name:'Last 14 days', resolution:'day', begin:-14, end:0}]</sv:value>
Index: content/src/main/resources/content/de/searchfacets.xml
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- content/src/main/resources/content/de/searchfacets.xml	(revision 36673)
+++ content/src/main/resources/content/de/searchfacets.xml	(revision )
@@ -47,6 +47,6 @@
     <sv:value>not(jcr:primaryType=tcmp:tagcloud)</sv:value>
   </sv:property>
   <sv:property sv:name="hippofacnav:limit" sv:type="Long">
-    <sv:value>1000</sv:value>
+    <sv:value>200</sv:value>
   </sv:property>
 </sv:node>
Index: content/src/main/resources/content/nl/products.xml
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- content/src/main/resources/content/nl/products.xml	(revision 36673)
+++ content/src/main/resources/content/nl/products.xml	(revision )
@@ -52,7 +52,7 @@
       <sv:value>hippogogreen:rating$[{name:'1 ster of meer', resolution:'double', begin:1}, {name:'2 sterren of meer', resolution:'double', begin:2}, {name:'3 sterren of meer', resolution:'double', begin:3}, {name:'4 sterren of meer', resolution:'double', begin:4}, {name:'5 sterren', resolution:'double', begin:5, end:6}]</sv:value>
     </sv:property>
     <sv:property sv:name="hippofacnav:limit" sv:type="Long">
-      <sv:value>1000</sv:value>
+      <sv:value>200</sv:value>
     </sv:property>
   </sv:node>
   <sv:node sv:name="hippo:translation">
Index: content/src/main/resources/content/en/products.xml
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- content/src/main/resources/content/en/products.xml	(revision 36673)
+++ content/src/main/resources/content/en/products.xml	(revision )
@@ -8642,7 +8642,7 @@
       <sv:value>hippogogreen:rating$[{name:'1 star or more', resolution:'double', begin:1}, {name:'2 stars or more', resolution:'double', begin:2}, {name:'3 stars or more', resolution:'double', begin:3}, {name:'4 stars or more', resolution:'double', begin:4}, {name:'5 stars', resolution:'double', begin:5, end:6}]</sv:value>
     </sv:property>
     <sv:property sv:name="hippofacnav:limit" sv:type="Long">
-      <sv:value>1000</sv:value>
+      <sv:value>200</sv:value>
     </sv:property>
   </sv:node>
   <sv:node sv:name="hippo:translation">
Index: content/src/main/resources/content/de/produkte.xml
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- content/src/main/resources/content/de/produkte.xml	(revision 36673)
+++ content/src/main/resources/content/de/produkte.xml	(revision )
@@ -56,7 +56,7 @@
       <sv:value>hippogogreen:rating$[{name:'1 Stern oder mehr', resolution:'double', begin:1}, {name:'2 oder mehr Sterne', resolution:'double', begin:2}, {name:'3 oder mehr Sterne', resolution:'double', begin:3}, {name:'4 Sterne oder mehr', resolution:'double', begin:4}, {name:'5 Sterne', resolution:'double', begin:5, end:6}]</sv:value>
     </sv:property>
     <sv:property sv:name="hippofacnav:limit" sv:type="Long">
-      <sv:value>1000</sv:value>
+      <sv:value>200</sv:value>
     </sv:property>
     <sv:property sv:name="hippofacnav:skipresultsetfacetsavailable" sv:type="Boolean">
       <sv:value>true</sv:value>
Index: content/src/main/resources/content/fr/products.xml
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- content/src/main/resources/content/fr/products.xml	(revision 36673)
+++ content/src/main/resources/content/fr/products.xml	(revision )
@@ -52,7 +52,7 @@
       <sv:value>hippogogreen:rating$[{name:'1 étoile ou plus', resolution:'double', begin:1},{name:'2 étoiles ou plus', resolution:'double', begin:2},{name:'3 étoiles ou plus', resolution:'double', begin:3},{name:'4 étoiles ou plus', resolution:'double', begin:4},{name:'5 étoiles', resolution:'double', begin:5, end:6}]</sv:value>
     </sv:property>
     <sv:property sv:name="hippofacnav:limit" sv:type="Long">
-      <sv:value>1000</sv:value>
+      <sv:value>200</sv:value>
     </sv:property>
   </sv:node>
   <sv:node sv:name="hippo:translation">
Index: content/src/main/resources/content/es/productos.xml
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- content/src/main/resources/content/es/productos.xml	(revision 36673)
+++ content/src/main/resources/content/es/productos.xml	(revision )
@@ -906,7 +906,7 @@
       <sv:value>hippogogreen:rating$[{name:'1 ster of meer', resolution:'double', begin:1}, {name:'2 sterren of meer', resolution:'double', begin:2}, {name:'3 sterren of meer', resolution:'double', begin:3}, {name:'4 sterren of meer', resolution:'double', begin:4}, {name:'5 sterren', resolution:'double', begin:5, end:6}]</sv:value>
     </sv:property>
     <sv:property sv:name="hippofacnav:limit" sv:type="Long">
-      <sv:value>1000</sv:value>
+      <sv:value>200</sv:value>
     </sv:property>
   </sv:node>
 </sv:node>
Index: content/src/main/resources/content/ru/searchfacets.xml
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- content/src/main/resources/content/ru/searchfacets.xml	(revision 36673)
+++ content/src/main/resources/content/ru/searchfacets.xml	(revision )
@@ -34,6 +34,6 @@
     <sv:value>not(jcr:primaryType=tcmp:tagcloud)</sv:value>
   </sv:property>
   <sv:property sv:name="hippofacnav:limit" sv:type="Long">
-    <sv:value>1000</sv:value>
+    <sv:value>200</sv:value>
   </sv:property>
 </sv:node>
Index: content/src/main/resources/content/fr/searchfacets.xml
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- content/src/main/resources/content/fr/searchfacets.xml	(revision 36673)
+++ content/src/main/resources/content/fr/searchfacets.xml	(revision )
@@ -48,6 +48,6 @@
     <sv:value>not(jcr:primaryType=tcmp:tagcloud)</sv:value>
   </sv:property>
   <sv:property sv:name="hippofacnav:limit" sv:type="Long">
-    <sv:value>1000</sv:value>
+    <sv:value>200</sv:value>
   </sv:property>
 </sv:node>
\ No newline at end of file
Index: content/src/main/resources/content/nl/searchfacets.xml
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- content/src/main/resources/content/nl/searchfacets.xml	(revision 36673)
+++ content/src/main/resources/content/nl/searchfacets.xml	(revision )
@@ -35,6 +35,6 @@
     <sv:value>not(jcr:primaryType=tcmp:tagcloud)</sv:value>
   </sv:property>
   <sv:property sv:name="hippofacnav:limit" sv:type="Long">
-    <sv:value>1000</sv:value>
+    <sv:value>200</sv:value>
   </sv:property>
 </sv:node>
Index: content/src/main/resources/content/ru/products.xml
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- content/src/main/resources/content/ru/products.xml	(revision 36673)
+++ content/src/main/resources/content/ru/products.xml	(revision )
@@ -901,7 +901,7 @@
       <sv:value>hippogogreen:rating$[{name:'1 звезда или больше', resolution:'double', begin:1}, {name:'2 звезды или больше', resolution:'double', begin:2}, {name:'3 звезды или больше', resolution:'double', begin:3}, {name:'4 звезды или больше', resolution:'double', begin:4}, {name:'5 звёзд', resolution:'double', begin:5, end:6}]</sv:value>
     </sv:property>
     <sv:property sv:name="hippofacnav:limit" sv:type="Long">
-      <sv:value>1000</sv:value>
+      <sv:value>200</sv:value>
     </sv:property>
   </sv:node>
 </sv:node>
Index: content/src/main/resources/content/en/searchfacets.xml
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- content/src/main/resources/content/en/searchfacets.xml	(revision 36673)
+++ content/src/main/resources/content/en/searchfacets.xml	(revision )
@@ -47,6 +47,6 @@
     <sv:value>not(jcr:primaryType=tcmp:tagcloud)</sv:value>
   </sv:property>
   <sv:property sv:name="hippofacnav:limit" sv:type="Long">
-    <sv:value>1000</sv:value>
+    <sv:value>200</sv:value>
   </sv:property>
 </sv:node>